#include "dscapture.h"
#include "pngwrite.h"
#include <stdio.h>

enum { lcdWidth=256, lcdHeight=192 };

uint16_t buf16[lcdWidth*lcdHeight*2];
uint8_t buf24[lcdWidth*lcdHeight*2*3];

static void BGR16toRGB24(uint8_t *out, uint16_t *in) {
    int i;
    for(i=0;i<lcdWidth*lcdHeight*2;i++) {
        unsigned char r,g,b;
        g=((*in)>>5)&0x3f;
        b=((*in<<1)&0x3e)|(g&1);
        r=(((*in)>>10)&0x3e)|(g&1);
        out[0]=(r<<2) | (r>>4);
        out[1]=(g<<2) | (g>>4);
        out[2]=(b<<2) | (b>>4);
        out+=3;
        in++;
    }
}

int main(int argc, char **argv) {

    char *filename="out.png";
    if(argc>1)
        filename=argv[1];

    if(!dscapture_init()) {
        printf("dscapture_init() error\n");
        goto end;
    }
    if(!dscapture_grabFrame(buf16)) {
        printf("dscapture_grabFrame() error\n");
        goto end;
    }
    BGR16toRGB24(buf24, buf16);
    if(writePNG_RGB24(filename, lcdWidth, lcdHeight*2, buf24))
        printf("Wrote %s\n", filename);

end:
    dscapture_deinit();
    return 0;
}